unit KeyP1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    PaintBox1: TPaintBox;
    procedure Button1Click(Sender: TObject);
    procedure doLoop;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure PaintBox1Paint(Sender: TObject);
  private
    ESCpressed : Boolean;
    LoopIt : Boolean;
    count: integer;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


procedure TForm1.doLoop;
begin
repeat
  PaintBox1.Repaint;
  Application.ProcessMessages;
  sleep(500);
until not LoopIt;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Loopit := false;
  ESCpressed:= false;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if key = VK_ESCAPE then ESCpressed:= true;
end;


procedure TForm1.PaintBox1Paint(Sender: TObject);
var col: TColor;
    i : integer;
    poly : array[0..4] of TPoint;
begin
  inc(count);
  label1.Caption:= IntToStr(count);
  PaintBox1.canvas.Brush.Color:= clWhite;
  PaintBox1.canvas.Fillrect (0,0,Paintbox1.Width, Paintbox1.Height);
  if ESCpressed then
     begin
       PaintBox1.Canvas.TextOut(10,10,'ESC');
       ESCpressed:=  false;
     end else
     begin
       Paintbox1.canvas.pen.color := clBlack;
       col := random ($FFFFFF);
       Paintbox1.canvas.Brush.color := col;
       for i := 0 to 4 do
         begin
         poly[i].x := random(Paintbox1.width);
         poly[i].y := random(Paintbox1.height);
         end;
       Paintbox1.canvas.Polygon(poly);
      end;
     application.ProcessMessages;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  s: String;
begin
 LoopIt := not LoopIt;
 if LoopIt then s := 'Stop' else s := 'Start';
 Button1.Caption:= s;
 Application.ProcessMessages;
 if LoopIt then doloop;
end;

end.

